// Vq (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>

#include "d88.h"

unsigned char buff[0x400*5*80];
unsigned char dir[0x400*3];
static char dirpath[FILENAME_MAX];				// 쐬fBNg

D88 disk;
FILE *fp;

bool msave(char *_fname, int _adr, int _size) {
//	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&buff[_adr], 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[]) {
	char fname[FILENAME_MAX];
	int i,j,d,r,diskno,filenum,trk;
	int s1,s2,s3;
	int mode=1;

	unsigned char id[] = "MKDS_3";

	if (argc < 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] [-d]\n",argv[0]);
		return 1;
	}
	if (argc > 2) {
		if (!strcmp(argv[2],"-d")) mode=0;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++) {
		if (mode) {
			sprintf(dirpath,"%03d",d);	// TufBNg̐
			_mkdir(dirpath);
			_chdir(dirpath);
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}

		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x05);
		// fBNgGgǂݍ
		disk.ReadDATA(0x4f, 0x27, 0x01, 0x03, 0x03, buff, 0x400*3);
		unsigned char *sp = &buff[0x400*3-1];
		unsigned char *dp = dir;

		// fBNgGgtɕۑ
		for (i=0; i<0x400*3; i++) {
			*dp++ = *sp--;
		}
		memset(buff, NULL, sizeof(buff));

#if 0
		fp = fopen("DIR", "wb");	// for debug
		fwrite(dir, 1, sizeof(dir), fp);
		fclose(fp);
#endif

		if (!memcmp(dir, id, sizeof(id)-1)) {
			diskno  = dir[6];
			filenum = dir[8];
			printf("Disk %d F܂.\n",diskno+1);
			printf("Number of file = %d\n",filenum);

			// fBXNC[Wǂݍ
			int s_trk = (diskno)? 0 : 1;
			for (trk=s_trk; trk<80; trk++) {
				disk.ReadDATA(trk, trk>>1, trk&1, 1, 3, &buff[(trk-s_trk)*0x400*5], 0x400*5);
			}

			sp = &dir[9];
			char xfn[11];
			char wfn[11];
			xfn[10] = '\0';
			int sumsize = 0;
			int size;

			for (i=0; i<filenum; i++) {
				// GR[ht@Cǂݎ
				s1 = *(sp)  *0x10000 + *(sp+1)*0x100 + *(sp+2);
				s2 = *(sp+3)*0x10000 + *(sp+4)*0x100 + *(sp+5);
				s3 = *(sp+6)>>2;
				// 6bit8bit֓WJ
				xfn[0]  = 0x20 + (char)((s1 & 0xfc0000)>>18);
				xfn[1]  = 0x20 + (char)((s1 & 0x03f000)>>12);
				xfn[2]  = 0x20 + (char)((s1 & 0x000fc0)>>6 );
				xfn[3]  = 0x20 + (char)((s1 & 0x00003f)    );
				xfn[4]  = 0x20 + (char)((s2 & 0xfc0000)>>18);
				xfn[5]  = 0x20 + (char)((s2 & 0x03f000)>>12);
				xfn[7]  = 0x20 + (char)((s2 & 0x000fc0)>>6 );
				xfn[6]  = (xfn[7] != ' ')? '.' : ' ';
				xfn[8]  = 0x20 + (char)((s2 & 0x00003f)    );
				xfn[9]  = 0x20 + (char)  s3;

				size = (*(sp+7) & 0x7f)*0x100 + *(sp+8);

				// o͗pɃt@C̃Xy[Xl߂
				int fnp=0;
				for (j=0; j<6; j++) {
					char c = xfn[j];
					if (c==' ') break;
					wfn[fnp++] = c;
				}
				for (j=6; j<10; j++) {
					char c = xfn[j];
					if (c==' ') break;
					wfn[fnp++] = c;
				}
				wfn[fnp] = '\0';
//				printf("%s\t%02x %02x %06x %04x\n",xfn,*(sp+7),*(sp+8), sumsize, size);
				printf("%s\tlocation: %06x  size: %04x",xfn, sumsize, size);
				if (*(sp+7) & 0x80) printf(" *");
				printf("\n");
				// o
				msave(wfn, sumsize, size);

				sumsize += size;

				sp += 9;
			}
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}

